Index: /branches/rel_avx_2_7_4/scripts/avxapps_startup.sh
===================================================================
--- /branches/rel_avx_2_7_4/scripts/avxapps_startup.sh	(revision 9092)
+++ /branches/rel_avx_2_7_4/scripts/avxapps_startup.sh	(working copy)
@@ -3,7 +3,8 @@
 GRUB_PATH=/boot/grub2/grub.cfg
 GRUBENV_PATH=/boot/grub2/grubenv
 SYSTEM_REBOOT_FLAG=/var/array/public/config/system_reboot_flag
- 
+model=`cat /var/array/public/config/arraymodel`
+
 if [ -f $SYSTEM_REBOOT_FLAG ];
 then
     rm -rf $SYSTEM_REBOOT_FLAG
@@ -111,6 +112,15 @@
     MEM_TOTAL=$(free | awk '{if($1=="Mem:"){print $2}}')
     AVX_HUGES=$(awk -F '=' '{if($1=="avx_hgpgs"){print $2}}' $GRUBENV_PATH)
     NEW_AVX_HUGES=5120
+
+    pcie_acs_override_changed=0
+    if [ "x${model}" == "x955800" ]; then
+            if ! grep -q pcie_acs_override $GRUB_PATH; then
+	                sed -i 's/intel_iommu=on/intel_iommu=on pcie_acs_override=downstream/g' $GRUB_PATH
+			pcie_acs_override_changed=1
+	    fi
+    fi
+
     if [ $MEM_TOTAL -gt 512000000 ]
     then
         NEW_AVX_HUGES=204800 #400G
@@ -137,6 +147,11 @@
     if [ $AVX_HUGES -ne $NEW_AVX_HUGES ]
     then
         sed -i "s/avx_hgpgs=.*/avx_hgpgs=$NEW_AVX_HUGES/g" $GRUBENV_PATH 
+    fi
+
+    if [ $pcie_acs_override_changed -eq 1 ] || [ $AVX_HUGES -ne $NEW_AVX_HUGES ]
+    then
+        pcie_acs_override_changed=0
         init 6
     fi
 
Index: /branches/rel_avx_2_7_4/scripts/avxapps_upgrade.sh
===================================================================
--- /branches/rel_avx_2_7_4/scripts/avxapps_upgrade.sh	(revision 9092)
+++ /branches/rel_avx_2_7_4/scripts/avxapps_upgrade.sh	(working copy)
@@ -113,7 +113,7 @@
 
     mtpt=$(lsblk -nl /dev/sda | awk '{if($7=="/"||$7=="/caupgrade"){print $1}}' | tr '\n' ' ')
     mtpt=${mtpt// /}
-    if `lscpu | grep 'Model name' | grep E3-1240 > /dev/null`; then
+    if [ "x${model}" == "x955800" ]; then
         if [ $mtpt == "sda3sda5" ] || [ $mtpt == "sda5sda3" ]; then
             install -m 0644 /caupgrade/ca/conf/system/grub.cfg.1U $GRUB_CFG_PATH 
         elif [ $mtpt == "sda5sda6" ] || [ $mtpt == "sda6sda5" ]; then
